/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



/**
 * Le Framework de jeux JavaScript Phaser
 *
Phaser v2.0.5 - http://phaser.io - @photonstorm - (c) 2014 Photon Storm Ltd. 
https://github.com/photonstorm/phaser
http://examples.phaser.io/
 */



/**
 * Les variables du jeu
 * 
 */

var game; 

var nNodeLength = 1;// longueur d'un élément : 1 pixel
var nNbreNodes = 369;// longueur du serpent

var aNodes = Array();
var oSerpent;
var bitmap;

var nWidth = 640;
var nHeight = 480;


document.addEventListener("DOMContentLoaded", Main, false); // appel au chargement de la page


/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    // creation de la zone de jeu - API canvas
    game = new Phaser.Game(nWidth, nHeight, Phaser.AUTO, "idGameDiv", {preload:onPreload, create:onCreate, update:onUpdate});
}


/**
 * Préchargement des éléments du jeu
 * 
 * @return {[type]} [description]
 */
function onPreload()
{ 
    game.stage.backgroundColor = '#cccccc';// la couleur de fond du jeu

    var nTypeMap = getRandomInt(1,2);// Génère un nombre entier aléatoire entre min (inclus) et max (inclus)

    // chargement d'une carte aléatoire
    if( nTypeMap == 1 )
        game.load.image("decor", "assets/map-google.png");
    else
        game.load.image("decor", "assets/map-youtube.png");

    // création de la structure du serpent
    for (i=0; i<nNbreNodes; i++) 
    {
        aNodes[i]=
        {
            x:0, y:0
        };
    };

}


/**
 * Génère un nombre entier aléatoire entre min (inclus) et max (inclus)
 * 
 */
function getRandomInt(min, max)
{
    return Math.floor( Math.random() * (max - min + 1) ) + min;
}




/**
 * Création de la scène du jeu,
 * mise en place des graphismes...
 * 
 * @return {[type]} [description]
 */
function onCreate() 
{
    // ajoute le décor du jeu à partir de l'image
    bitmap = game.make.bitmapData(nWidth, nHeight);
    bitmap.draw("decor");
    bitmap.update();
    game.add.sprite(0,0,bitmap);

    oSerpent = game.add.graphics(0,0); // le serpent
}


/**
 * Appelée en continu pendant le jeu
 * 
 * @return {[type]} [description]
 */
function onUpdate() 
{
    oSerpent.clear();
    oSerpent.alpha=1;
    oSerpent.lineStyle(2,0x2E64FE,1);// sa couleur

    // déplace le serpent par rapport à la souris
    var headX = game.input.x;
    var headY = game.input.y;

    oSerpent.moveTo(headX,headY);
    aNodes[0]={ x:headX, y:headY };

    // parcours tous les pixels du serpent
    for( i=1;i<nNbreNodes-1;i++ )
    {
        var nodeAngle = Math.atan2(aNodes[i].y-aNodes[i-1].y,aNodes[i].x-aNodes[i-1].x);
        
        aNodes[i]=
        {
            x: aNodes[i-1].x + nNodeLength * Math.cos(nodeAngle),
            y: aNodes[i-1].y + nNodeLength * Math.sin(nodeAngle) 
        }

        // récupère la couleur du pixel
        var color = bitmap.getPixelRGB(Math.round(aNodes[i].x),Math.round(aNodes[i].y));
        
        // si la couleur n'est pas transparente alors collision
        if( color.a != 0 )
            oSerpent.lineStyle(2,0xff0000,1);// le serpent devient rouge

        oSerpent.lineTo(aNodes[i].x,aNodes[i].y);
    }
    
}



